//##########################################################################################
//## SLIDOS PLATNICOS                                                                   ##
//## Clausius Duque G. Reis - 66812                                                       ##
//##########################################################################################

#include <windows.h>
#include <GL\glu.h>
#include <math.h>

HDC			hDC=NULL;
HGLRC		hRC=NULL;
HWND		hWnd=NULL;
HINSTANCE	hInstance;

bool	keys[256];
bool	active=TRUE;
bool	fullscreen=TRUE;

//##########################################################################################
//##########################################################################################
//##########################################################################################
GLfloat	rotateAngle;

float phi = (1 + sqrt(5)) / 2;
float A = 1/sqrt(3);
float B = 1 / phi;
float C = 1 / (phi * phi);
float X = 0.525731112119133606f;
float Z = 0.850650808352039932f;

struct s_vertice // Estrutura para armazenar vertices
{
	double x,y,z;
};
typedef struct s_vertice vertice;


// Tetraedro
int num_face_tetra = 3;
vertice faces_tetra[4][3] = {{{A,A,A},{-A,-A,A},{A,-A,-A}},
						     {{-A,A,-A},{A,A,A},{A,-A,-A}},
						     {{-A,-A,A},{A,A,A},{-A,A,-A}},
						     {{A,-A,-A},{-A,-A,A},{-A,A,-A}}};

// Hexaedro
int num_face_hexa = 5;
vertice faces_hexa[6][4] = {{{A,A,A},{A,A,-A},{-A,A,-A},{-A,A,A}},	  
					        {{-A,A,A},{-A,A,-A},{-A,-A,-A},{-A,-A,A}},
					        {{-A,-A,A},{-A,-A,-A},{A,-A,-A},{A,-A,A}},
					        {{A,-A,A},{A,-A,-A},{A,A,-A},{A,A,A}},    
					        {{A,A,-A},{A,-A,-A},{-A,-A,-A},{-A,A,-A}},
					        {{A,A,A},{-A,A,A},{-A,-A,A},{A,-A,A}}};   

// Octaedro
int num_face_octa = 7;
vertice faces_octa[8][3] = {{{1,0,0},{0,1,0},{0,0,1}},   
                            {{0,1,0},{-1,0,0},{0,0,1}},  
						    {{-1,0,0},{0,-1,0},{0,0,1}}, 
					  	    {{0,-1,0},{1,0,0},{0,0,1}},  
						    {{0,1,0},{1,0,0},{0,0,-1}},  
						    {{-1,0,0},{0,1,0},{0,0,-1}}, 
						    {{0,-1,0},{-1,0,0},{0,0,-1}},
						    {{1,0,0},{0,-1,0},{0,0,-1}}};

// Dodecaedro
int num_face_dode = 11;
vertice faces_dode[12][5] =  {{{C,   0,  1},  {-C,  0, 1},   {-B,  B, B},   {0,   1,  C},  {B,   B,  B} },
                             {{-C,  0,  1},  {C,   0, 1},   { B, -B, B},   { 0, -1,  C},  {-B, -B,  B} },
                             {{ C,  0, -1},  {-C,  0, -1},  {-B, -B, -B},  { 0, -1, -C},  { B, -B, -B} },
                             {{-C,  0, -1},  { C,  0, -1},  { B,  B, -B},  { 0,  1, -C},  {-B,  B, -B} },
                             {{ 0,  1, -C},  { 0,  1,  C},  { B,  B,  B},  { 1,  C,  0},  { B,  B, -B} },
                             {{ 0,  1,  C},  { 0,  1, -C},  {-B,  B, -B},  {-1,  C,  0},  {-B,  B,  B} },
                             {{ 0, -1, -C},  { 0, -1,  C},  {-B, -B,  B},  {-1, -C,  0},  {-B, -B, -B} },
                             {{ 0, -1,  C},  { 0, -1, -C},  { B, -B, -B},  { 1, -C,  0},  { B, -B,  B} },
                             {{ 1,  C,  0},  { 1, -C,  0},  { B, -B,  B},  { C,  0,  1},  { B,  B,  B} },
                             {{ 1, -C,  0},  { 1,  C,  0},  { B,  B, -B},  { C,  0, -1},  { B, -B, -B} },
                             {{-1,  C,  0},  {-1, -C,  0},  {-B, -B, -B},  {-C,  0, -1},  {-B,  B, -B} },
                             {{-1, -C,  0},  {-1,  C,  0},  {-B,  B,  B},  {-C,  0,  1},  {-B, -B,  B} }};

// Icosaedro
int num_face_ico = 19;
vertice faces_ico[20][3] = {{{0,Z,X},{-X,0,Z},{X,0,Z}},	    
							{{-Z,X,0},{-X,0,Z},{0,Z,X}},	
							{{0,Z,-X},{-Z,X,0},{0,Z,X}},	
							{{0,Z,-X},{0,Z,X},{Z,X,0}},		
							{{Z,X,0},{0,Z,X},{X,0,Z}},		
							{{Z,-X,0},{Z,X,0},{X,0,Z}},		
							{{X,0,-Z},{Z,X,0},{Z,-X,0}},	
							{{X,0,-Z},{0,Z,-X},{Z,X,0}},	
							{{-X,0,-Z},{0,Z,-X},{X,0,-Z}},  
							{{0,-Z,-X},{-X,0,-Z},{X,0,-Z}}, 
							{{Z,-X,0},{0,-Z,-X},{X,0,-Z}},  
							{{0,-Z,X},{0,-Z,-X},{Z,-X,0}},  
							{{-Z,-X,0},{0,-Z,-X},{0,-Z,X}}, 
							{{-X,0,Z},{-Z,-X,0},{0,-Z,X}},	
							{{X,0,Z},{-X,0,Z},{0,-Z,X}},	
							{{X,0,Z},{0,-Z,X},{Z,-X,0}},	
							{{-X,0,Z},{-Z,X,0},{-Z,-X,0}},  
							{{-Z,-X,0},{-Z,X,0},{-X,0,-Z}}, 
							{{-X,0,-Z},{-Z,X,0},{0,Z,-X}},	
							{{-X,0,-Z},{0,-Z,-X},{-Z,-X,0}}};

int DrawGLScene(GLvoid)								
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); //GL_FILL
   	rotateAngle+=0.05f;	
	int v = 0;


    // Tetraedro
	glLoadIdentity();	
	glTranslatef(-2.5f,1.5f,-8.0f);
	glRotatef(rotateAngle,1.0f,1.0f,1.0f);
	glBegin(GL_POLYGON);
	glColor3f(0.0f,1.0f,0.0f);			
    	v = 0;
    	while (v <= num_face_tetra) {
           glVertex3f( faces_tetra[v][0].x, faces_tetra[v][0].y, faces_tetra[v][0].z);
           glVertex3f( faces_tetra[v][1].x, faces_tetra[v][1].y, faces_tetra[v][1].z);
           glVertex3f( faces_tetra[v][2].x, faces_tetra[v][2].y, faces_tetra[v][2].z);
           v += 1;
       	}
	glEnd();


    // Hexaedro
	glLoadIdentity();	
	glTranslatef(0.0f,1.5f,-8.0f);
	glRotatef(rotateAngle,1.0f,1.0f,1.0f);
	glBegin(GL_QUADS);
	glColor3f(0.0f,1.0f,0.0f);			
    	v = 0;
    	while (v <= num_face_hexa) {
           glVertex3f( faces_hexa[v][0].x, faces_hexa[v][0].y, faces_hexa[v][0].z);
           glVertex3f( faces_hexa[v][1].x, faces_hexa[v][1].y, faces_hexa[v][1].z);
           glVertex3f( faces_hexa[v][2].x, faces_hexa[v][2].y, faces_hexa[v][2].z);
           glVertex3f( faces_hexa[v][3].x, faces_hexa[v][3].y, faces_hexa[v][3].z);
           v += 1;
       	}
	glEnd();


    // Octaedro
	glLoadIdentity();	
	glTranslatef(-1.2f,-1.5f,-8.0f);
	glRotatef(rotateAngle,1.0f,1.0f,1.0f);
	glBegin(GL_POLYGON);
	glColor3f(0.0f,1.0f,0.0f);			
    	v = 0;
    	while (v <= num_face_octa) {
           glVertex3f( faces_octa[v][0].x, faces_octa[v][0].y, faces_octa[v][0].z);
           glVertex3f( faces_octa[v][1].x, faces_octa[v][1].y, faces_octa[v][1].z);
           glVertex3f( faces_octa[v][2].x, faces_octa[v][2].y, faces_octa[v][2].z);
           v += 1;
       	}
	glEnd();


    // Dodecaedro
	glLoadIdentity();						
	glTranslatef(2.5f,1.5f,-8.0f);			
	glRotatef(rotateAngle,1.0f,1.0f,1.0f);
	v = 0;
    	while (v <= num_face_dode) {
           glBegin(GL_POLYGON);
	       glColor3f(0.0f,1.0f,0.0f);
           glVertex3f( faces_dode[v][0].x, faces_dode[v][0].y, faces_dode[v][0].z);
           glVertex3f( faces_dode[v][1].x, faces_dode[v][1].y, faces_dode[v][1].z);
           glVertex3f( faces_dode[v][2].x, faces_dode[v][2].y, faces_dode[v][2].z);
           glVertex3f( faces_dode[v][3].x, faces_dode[v][3].y, faces_dode[v][3].z);
           glVertex3f( faces_dode[v][4].x, faces_dode[v][4].y, faces_dode[v][4].z);           
           glEnd();
           v += 1;
       	}

	
    // Icosaedro
	glLoadIdentity();	
	glTranslatef(1.2f,-1.5f,-8.0f);
	glRotatef(rotateAngle,1.0f,1.0f,1.0f);
	glBegin(GL_TRIANGLES);
	glColor3f(0.0f,1.0f,0.0f);			
    	v = 0;
    	while (v <= num_face_ico) {
           glVertex3f( faces_ico[v][0].x, faces_ico[v][0].y, faces_ico[v][0].z);
           glVertex3f( faces_ico[v][1].x, faces_ico[v][1].y, faces_ico[v][1].z);
           glVertex3f( faces_ico[v][2].x, faces_ico[v][2].y, faces_ico[v][2].z);
           v += 1;
       	}
	glEnd();




	return TRUE;
}

//##########################################################################################
//##########################################################################################
//##########################################################################################





LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)	
{
	if (height==0)									
	{
		height=1;									
	}

	glViewport(0,0,width,height);					

	glMatrixMode(GL_PROJECTION);					
	glLoadIdentity();								

	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();		
}

int InitGL(GLvoid)			
{
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);
	glClearDepth(1.0f);					
	glEnable(GL_DEPTH_TEST);			
	glDepthFunc(GL_LEQUAL);				
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	return TRUE;									
}

GLvoid KillGLWindow(GLvoid)	
{
	if (fullscreen)			
	{
		ChangeDisplaySettings(NULL,0);	
		ShowCursor(TRUE);				
	}

	if (hRC)							
	{
		if (!wglMakeCurrent(NULL,NULL))
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;				
	}

	if (hDC && !ReleaseDC(hWnd,hDC))	
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;
	}

	if (hWnd && !DestroyWindow(hWnd))
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;					
	}

	if (!UnregisterClass("OpenGL",hInstance))
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;						
	}
}


BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			
	WNDCLASS	wc;						
	DWORD		dwExStyle;				
	DWORD		dwStyle;				
	RECT		WindowRect;				
	WindowRect.left=(long)0;			
	WindowRect.right=(long)width;		
	WindowRect.top=(long)0;				
	WindowRect.bottom=(long)height;		

	fullscreen=fullscreenflag;			

	hInstance			= GetModuleHandle(NULL);				
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	
	wc.lpfnWndProc		= (WNDPROC) WndProc;					
	wc.cbClsExtra		= 0;									
	wc.cbWndExtra		= 0;									
	wc.hInstance		= hInstance;							
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			
	wc.hbrBackground	= NULL;									
	wc.lpszMenuName		= NULL;									
	wc.lpszClassName	= "OpenGL";								

	if (!RegisterClass(&wc))									
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											
	}
	
	if (fullscreen)												
	{
		DEVMODE dmScreenSettings;								
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		
		dmScreenSettings.dmPelsWidth	= width;				
		dmScreenSettings.dmPelsHeight	= height;				
		dmScreenSettings.dmBitsPerPel	= bits;					
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{

			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;
			}
			else
			{
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;
			}
		}
	}

	if (fullscreen)
	{
		dwExStyle=WS_EX_APPWINDOW;
		dwStyle=WS_POPUP;		
		ShowCursor(FALSE);		
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;	
		dwStyle=WS_OVERLAPPEDWINDOW;					
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);


	if (!(hWnd=CreateWindowEx(	dwExStyle,							
								"OpenGL",							
								title,								
								dwStyle |							
								WS_CLIPSIBLINGS |					
								WS_CLIPCHILDREN,					
								0, 0,								
								WindowRect.right-WindowRect.left,	
								WindowRect.bottom-WindowRect.top,	
								NULL,								
								NULL,								
								hInstance,							
								NULL)))								
	{
		KillGLWindow();						
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;						
	}

	static	PIXELFORMATDESCRIPTOR pfd=		
	{
		sizeof(PIXELFORMATDESCRIPTOR),		
		1,									
		PFD_DRAW_TO_WINDOW |				
		PFD_SUPPORT_OPENGL |				
		PFD_DOUBLEBUFFER,							
		PFD_TYPE_RGBA,								
		bits,										
		0, 0, 0, 0, 0, 0,							
		0,											
		0,											
		0,											
		0, 0, 0, 0,									
		16,											
		0,											
		0,											
		PFD_MAIN_PLANE,								
		0,											
		0, 0, 0										
	};
	
	if (!(hDC=GetDC(hWnd)))							
	{
		KillGLWindow();								
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	
	{
		KillGLWindow();								
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		
	{
		KillGLWindow();								
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if (!(hRC=wglCreateContext(hDC)))				
	{
		KillGLWindow();								
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	if(!wglMakeCurrent(hDC,hRC))					
	{
		KillGLWindow();								
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	ShowWindow(hWnd,SW_SHOW);						
	SetForegroundWindow(hWnd);						
	SetFocus(hWnd);									
	ReSizeGLScene(width, height);					

	if (!InitGL())									
	{
		KillGLWindow();								
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								
	}

	return TRUE;									
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			
							UINT	uMsg,			
							WPARAM	wParam,			
							LPARAM	lParam)			
{
	switch (uMsg)									
	{
		case WM_ACTIVATE:							
		{
			if (!HIWORD(wParam))					
			{
				active=TRUE;						
			}
			else
			{
				active=FALSE;						
			}

			return 0;								
		}

		case WM_SYSCOMMAND:							
		{
			switch (wParam)							
			{
				case SC_SCREENSAVE:					
				case SC_MONITORPOWER:				
				return 0;							
			}
			break;									
		}

		case WM_CLOSE:								
		{
			PostQuitMessage(0);						
			return 0;								
		}

		case WM_KEYDOWN:							
		{
			keys[wParam] = TRUE;					
			return 0;								
		}

		case WM_KEYUP:								
		{
			keys[wParam] = FALSE;					
			return 0;								
		}

		case WM_SIZE:								
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  
			return 0;								
		}
	}

	
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			
					HINSTANCE	hPrevInstance,		
					LPSTR		lpCmdLine,			
					int			nCmdShow)			
{
	MSG		msg;									
	BOOL	done=FALSE;								


	if (MessageBox(NULL,"Gostaria de executar em tela inteira??", "Tela inteira?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;
	}

	if (!CreateGLWindow("Slidos Platnicos - Clausius Reis 66812",640,480,16,fullscreen))
	{
		return 0;									
	}

	while(!done)									
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	
		{
			if (msg.message==WM_QUIT)				
			{
				done=TRUE;							
			}
			else									
			{
				TranslateMessage(&msg);			
				DispatchMessage(&msg);			
			}
		}
		else	
		{

			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])
			{
				done=TRUE;							
			}
			else									
			{
				SwapBuffers(hDC);					
			}

			if (keys[VK_F1])						
			{
				keys[VK_F1]=FALSE;					
				KillGLWindow();						
				fullscreen=!fullscreen;				

				if (!CreateGLWindow("Slidos Platnicos - Clausius Reis 66812",640,480,16,fullscreen))
				{
					return 0;			
				}
			}
		}
	}


	KillGLWindow();						
	return (msg.wParam);				
}
